#include <iostream>
#include <string>
#include <sstream>
#include <fstream>
#include <vector>

using namespace std;

void convertor(string opb_file_name, string cnf_file_name, string output_file_name)
{
    long long num_vars, num_clauses, num_softclauses, num_hardclauses, num_constraints;
    long long top_clause_weight;

    ifstream opb_ifile(opb_file_name.c_str());
    ifstream cnf_ifile(cnf_file_name.c_str());
    ofstream wcnf_ofile(output_file_name.c_str());

    stringstream ss;
    string line, line2, line3;

    getline(cnf_ifile, line);
    ss.clear();
    ss.str(line);
    ss.seekg(0, ios::beg);
    ss >> line2 >> line3 >> num_vars >> num_hardclauses;

    string coeff, var;
    getline(opb_ifile, line);
    while(line[0]=='*') {getline(opb_ifile, line);}
    //getline(opb_ifile, line);
    ss.clear();
    ss.str(line);
    ss.seekg(0, ios::beg);
    ss >> coeff;
    ss >> coeff >> var;
    long long icoeff, ivar;
    num_softclauses = 0;
    top_clause_weight = 0;
    while (coeff != ";")
    {
        stringstream ss2;
        ss2.clear();
        ss2.str(coeff);
        ss2.seekg(0, ios::beg);
        ss2 >> icoeff;
        ss2.clear();
        ss2.str(var.substr(1));
        ss2.seekg(0, ios::beg);
        ss2 >> ivar;
        num_softclauses++;
        if(icoeff>0)
        	top_clause_weight += icoeff;
        else top_clause_weight += (-icoeff);
        ss >> coeff >> var;
    }
    wcnf_ofile << "p wcnf " << num_vars << " " << num_hardclauses + num_softclauses << " " << ++top_clause_weight << endl;

    ss.clear();
    ss.str(line);
    ss.seekg(0, ios::beg);
    ss >> coeff;
    ss >> coeff >> var;
    while (coeff != ";")
    {
        stringstream ss2;
        ss2.clear();
        ss2.str(coeff);
        ss2.seekg(0, ios::beg);
        ss2 >> icoeff;
        ss2.clear();
        ss2.str(var.substr(1));
        ss2.seekg(0, ios::beg);
        ss2 >> ivar;
        if (icoeff < 0)
        {
            wcnf_ofile << -icoeff << " " << ivar << " 0" << endl;
        }
        else
        {
            wcnf_ofile << icoeff << " " << -ivar << " 0" << endl;
        }
        ss >> coeff >> var;
    }
    opb_ifile.close();

    for (int i = 0; i < num_hardclauses; ++i)
    {
        getline(cnf_ifile, line);
        wcnf_ofile << top_clause_weight << " " << line << endl;
    }
    cnf_ifile.close();
    wcnf_ofile.close();
}

int main(int argc, char *argv[])
{
    convertor(argv[1], argv[2], argv[3]);
}
